#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#define true 1
#define false 0
// 点
struct point{ double x;double y;};
struct point points[10001];
struct point result_points[1000001];
struct polygon_type{
	struct point points[10001];
	int point_number;
	double max_distance;
	// ポリゴンをおおう正方形
	double minx,maxx,miny,maxy;
};
// 二乗を求める関数
double pow2(double val){
	return val * val;
}
struct polygon_type polygon;
struct polygon_type polygons[100];
struct point minpoint;

void MakePolygon(){
	int i;
	double dist;
	double minx,miny,maxx,maxy;
	polygon.max_distance = 0;
	polygon.points[0].x= 10000*cos((double)0 /10000 * M_PI * 2); 
	polygon.points[0].y = 10000*sin((double)0 /10000 * M_PI * 2); 
	minx = polygon.points[0].x;
	miny = polygon.points[0].y;
	maxx = polygon.points[0].x;
	maxy = polygon.points[0].y;
	for(i = 1;i<=10000;i++){
		polygon.points[i].x = 10000*cos((double)i /10000 * M_PI * 2); 
		polygon.points[i].y = 10000*sin((double)i /10000 * M_PI *2); 
		dist = sqrt(pow2(polygon.points[i].x-polygon.points[i-1].x)+pow2(polygon.points[i].y-polygon.points[i-1].y));
		polygon.max_distance = polygon.max_distance > dist ? polygon.max_distance : dist;
		minx = polygon.points[i].x < minx ? polygon.points[i].x : minx;
		miny = polygon.points[i].y < miny ? polygon.points[i].y : miny;
		maxx = polygon.points[i].x > maxx ? polygon.points[i].x : maxx;
		maxy = polygon.points[i].y > maxy ? polygon.points[i].y : maxy;
	}
	polygon.minx = minx;
	polygon.miny = miny;
	polygon.maxx = maxx;
	polygon.maxy = maxy;
	polygon.point_number=10000;
}
void MakePolygons(){
	int i,j;
	int point_number;
	double dist;
	double x,y;
	double minx,miny,maxx,maxy;
	
	for(i = 0; i<100 ;i++){
		point_number = 10000;
		polygons[i].point_number = point_number;
		dist = 10000;
		x = rand()%15000-5000;
		y = rand()%15000-5000;
		
		polygons[i].points[0].x= dist*cos((double)0 /point_number * M_PI * 2) + x ;
		polygons[i].points[0].y = dist*sin((double)0 /point_number * M_PI * 2) + y; 
		minx = polygons[i].points[0].x;
		miny = polygons[i].points[0].y;
		maxx = polygons[i].points[0].x;
		maxy = polygons[i].points[0].y;
		for(j=0;j<=point_number;j++){
			polygons[i].points[j].x = dist*cos((double)j /point_number * M_PI * 2) +x; 
			polygons[i].points[j].y = dist*sin((double)j /point_number * M_PI *2) + y; 
			dist = sqrt(pow2(polygons[i].points[j].x-polygons[i].points[j-1].x)+pow2(polygons[i].points[j].y-polygons[i].points[j-1].y));
			polygons[i].max_distance = polygons[i].max_distance > dist ? polygons[i].max_distance : dist;
			minx = polygons[i].points[j].x < minx ? polygons[i].points[j].x : minx;
			miny = polygons[i].points[j].y < miny ? polygons[i].points[j].y : miny;
			maxx = polygons[i].points[j].x > maxx ? polygons[i].points[j].x : maxx;
			maxy = polygons[i].points[j].y > maxy ? polygons[i].points[j].y : maxy;
		}
		polygons[i].minx = minx;
		polygons[i].miny = miny;
		polygons[i].maxx = maxx;
		polygons[i].maxy = maxy;
	}
}
void SimpleMethod(){
	int i,j,k,l=0;
	double ksi,eta,delta,lambda,mu;
	struct point CrossP;
	FILE *fp;
	fp = fopen("tmp2","w");
	for(i = 0 ;i<100;i++){
		if(polygons[i].maxx < polygon.minx || polygons[i].minx > polygon.maxx || polygons[i].maxy < polygon.miny || polygons[i].miny > polygon.maxy){
			continue;
		}
		for(k=0;k<polygons[i].point_number-1;k++){
		
		for(j =0;j<polygon.point_number-1;j++){
			l++;
			ksi = ( polygon.points[j+1].y-polygon.points[j].y )*( polygon.points[j+1].x-polygons[i].points[k].x ) - 
					( polygon.points[j+1].x-polygon.points[j].x )*( polygon.points[j+1].y-polygons[i].points[k].y );
			eta = ( polygons[i].points[k+1].x-polygons[i].points[k].x )*( polygon.points[j+1].y-polygons[i].points[k].y ) -
				( polygons[i].points[k+1].y-polygons[i].points[k].y)*( polygon.points[j+1].x-polygons[i].points[k].x );
			delta = ( polygons[i].points[k+1].x-polygons[i].points[k].x )*( polygon.points[j+1].y-polygon.points[j].y ) -
				( polygons[i].points[k+1].y-polygons[i].points[k].y)*( polygon.points[j+1].x-polygon.points[j].x );
			lambda = ksi/delta;	
			mu = eta /delta;
			if( lambda>=0 && lambda<=1 && mu >= 0 && mu<=1){
			CrossP.x = polygons[i].points[k].x + lambda*(polygons[i].points[k+1].x- polygons[i].points[k].x);	
			CrossP.y = polygons[i].points[k].y + lambda*(polygons[i].points[k+1].y- polygons[i].points[k].y);	
				fprintf(fp,"segment %f %f %f %f\n",polygon.points[j].x,polygon.points[j].y,polygon.points[j+1].x,polygon.points[j+1].y);
				fprintf(fp,"segment2 %f %f %f %f\n",polygons[i].points[k].x,polygons[i].points[k].y,polygons[i].points[k+1].x,polygons[i].points[k+1].y);
				fprintf(fp,"Cross points %f %f\n",CrossP.x,CrossP.y);
			}
		}
		} 
	}	
}
void KangarooMethod(){
	int i,j,k,l=0;
	double ksi,eta,delta,lambda,mu;
	double dx,dy,a,b,t,x,y;
	double diffx,diffy;
	int jump;
	struct point CrossP;
	FILE *fp;
	fp = fopen("tmp3","w");
	for(i = 0 ;i<100;i++){
		if(polygons[i].maxx < polygon.minx || polygons[i].minx > polygon.maxx || polygons[i].maxy < polygon.miny || polygons[i].miny > polygon.maxy){
			continue;
		}
		for(k=0;k<polygons[i].point_number-1;){
		
		for(j =0;j<polygon.point_number-1;){
			ksi = ( polygon.points[j+1].y-polygon.points[j].y )*( polygon.points[j+1].x-polygons[i].points[k].x ) - 
					( polygon.points[j+1].x-polygon.points[j].x )*( polygon.points[j+1].y-polygons[i].points[k].y );
			eta = ( polygons[i].points[k+1].x-polygons[i].points[k].x )*( polygon.points[j+1].y-polygons[i].points[k].y ) -
				( polygons[i].points[k+1].y-polygons[i].points[k].y)*( polygon.points[j+1].x-polygons[i].points[k].x );
			delta = ( polygons[i].points[k+1].x-polygons[i].points[k].x )*( polygon.points[j+1].y-polygon.points[j].y ) -
				( polygons[i].points[k+1].y-polygons[i].points[k].y)*( polygon.points[j+1].x-polygon.points[j].x );
			lambda = ksi/delta;	
			mu = eta /delta;
			// 交わっている時
			if( lambda>=0 && lambda<=1 && mu >= 0 && mu<=1){
				CrossP.x = polygons[i].points[k].x + lambda*(polygons[i].points[k+1].x- polygons[i].points[k].x);	
				CrossP.y = polygons[i].points[k].y + lambda*(polygons[i].points[k+1].y- polygons[i].points[k].y);	
				fprintf(fp,"segment %f %f %f %f\n",polygon.points[j].x,polygon.points[j].y,polygon.points[j+1].x,polygon.points[j+1].y);
				fprintf(fp,"segment2 %f %f %f %f\n",polygons[i].points[k].x,polygons[i].points[k].y,polygons[i].points[k+1].x,polygons[i].points[k+1].y);
				fprintf(fp,"Cross points %f %f\n",CrossP.x,CrossP.y);
			}
			// 辺どうしの距離を計算
			// calculate the distance between the edges
			dx = polygons[i].points[k+1].x-	polygons[i].points[k].x;	
			dy = polygons[i].points[k+1].y-	polygons[i].points[k].y;	
			a = dx* dx + dy * dy;
			// aが0になるのはありえないが一応除外
			// a can not be 0 but anyway I exclude
			if(a == 0){
				jump = (int)sqrt(pow2(polygons[i].points[k].x - polygon.points[j+1].x) + pow2(polygons[i].points[k].y - polygon.points[j+1].y))/polygon.max_distance+ 1;
			}else{
				b = dx * (polygons[i].points[k].x - polygon.points[j+1].x) + dy * (polygons[i].points[k].y - polygon.points[j+1].y);
				t = -b/a;
				// 辺との距離を計算するために辺にもっとも近い点を計算(tが0またはtが１の時は端）
				// To calculate the distance between the edges calculate the point which is nearest to the edge.When t is 0 or t is 1 then it is on the  end of the edge
				if( t<0) t = 0;
				if( t>1) t = 1;
				x = t*dx + polygons[i].points[k].x;
				y = t*dy + polygons[i].points[k].y;

				jump = (int)(sqrt(pow2(x - polygon.points[j+1].x) + pow2(y - polygon.points[j+1].y))/polygon.max_distance) + 1;
			}
			j+=jump;
			l++;
			
		}
		diffx=0;
		diffy=0;
		// 多角形と正方形との距離からjumpを決める
		// 実際はあまり速くならないのでシンプルにk++でもよい
		// determine the jump by distance between the smaller polygon and the square
		if(polygon.minx > polygons[i].points[k+1].x){
			diffx = polygon.minx-polygons[i].points[k+1].x;
		}else if(polygon.maxx < polygons[i].points[k+1].x){
			diffx = polygons[i].points[k+1].x - polygon.maxx;
		}
		if(polygon.miny > polygons[i].points[k+1].y){
			diffy = polygon.miny-polygons[i].points[k+1].y;
		}else if(polygon.maxy < polygons[i].points[k+1].y){
			diffy = polygons[i].points[k+1].y - polygon.maxy;
		} 
		if(diffx > diffy){
			jump = (int)(diffx / polygons[i].max_distance) + 1;
		}else{ 
			jump = (int)(diffy / polygons[i].max_distance) + 1;
		}
		k+=jump;
		}	
	}	
}
int main(){
	int t1,t2;
		
	
	
	MakePolygon();
	MakePolygons();
	t1 = clock();
	SimpleMethod();
	t2 = clock();
	printf("time1 = %f[s]\n", (double)(t2-t1)/CLOCKS_PER_SEC);
	t1 = clock();
	KangarooMethod();
	t2 = clock();
	printf("time2 = %f[s]\n", (double)(t2-t1)/CLOCKS_PER_SEC);
}
